package Hdd060 ;
#use strict; => quand le code sera optimis

# Initialisation des modules ncessaires au bon fonctionnement

use MP3::Tag ; #Pour travailler sur les tags mp3
use MP3::Info ;
use DBD::SQLite2 ; #Pour travailler sur BDD Sqlite
#use Digest::MD5 qw(md5 md5_hex md5_base64) ; #juste pour renommer le fichier de facon unique : fonction remplace par md5sum du shell linux

my $dbh ; # reference  ma base de donne $bdd


# Variables de test :
my $ptmontage = "/home/olivier/Prog/hdd060/" ;
my $repchant = "_system/media/audio/";
my $bdd = "_system/media/audio/MyDB" ;

# Variables dfinitives
#my $ptmontage = "/mnt/hd/" ;
#my $repchant = "_system/media/audio/";
#my $bdd = "_system/media/audio/MyDB" ;

sub lire_Tags {
	my ($piste) = @_ ; # lecteur des arguments pass  la fonction
	
	$idtags = MP3::Tag->new($piste) ;
	$idtags->get_tags ;
	if (exists $idtags->{ID3v1}) {
		#lire tous les tags 
	    $id3v1=$idtags->{ID3v1} ;
	    @tagdata=$id3v1->all(); # stock sous forme de liste \ 
	    # dans l'ordre : Titre, artiste, album, anne, commentaire, piste , genre)
	        # $titre   = $id3v1->title ;
	        # $artist  = $id3v1->artist;
            # $album   = $id3v1->album;
            # $year    = $id3v1->year;
            # $comment = $id3v1->comment;
            # $track   = $id3v1->track;
            # $genre   = $id3v1->genre;
	}
	#if (exists $idtags->{ID3v2}) {
             # read some information from the tag
             # A implmenter plus tard si necessaire
    #    }

    my $info = get_mp3info($piste) or die "Pas d'informations trouvs sur la piste" ;
	# Affectation des variables pour la table songTable
	@tagdata = ( @tagdata, $info->{BITRATE} ) or die "Pas de bitrate"; #=tagdata[7]
	@tagdata = ( @tagdata, int($info->{SECS}) ) or die "Pas de dure"; #=tagdata[8]
	@tagdata = ( @tagdata, (($info->{FREQUENCY})*1000)  )or die "Pas de samplerate" ; #=tagdata[9]
	@tagdata = ( @tagdata, int(($info->{SIZE})/1024) )  or die "Pas de taille" ; #=tagdata[10]
    my $filename_MD5=<FICHIER> and close(FICHIER) if (open(FICHIER,"md5sum \"$piste\"|"));
    my @filename_MD5 = split(' ',$filename_MD5) ;
    @tagdata = ( @tagdata, $filename_MD5[0] . ".mp3" );#=tagdata[11]
    
return @tagdata ;
}

sub lecture_Bdd {
    my %table_Tag = () ;
    my $sql = "SELECT iSongId, cSongTitle, iArtistId, iAlbumId, iGenreId FROM songTable";
    $dbh = DBI->connect("dbi:SQLite2:$ptmontage$bdd","","") or die "Couldn't connect to database: ". DBI->errstr;
    $sth = $dbh->prepare($sql) or die "Couldnt prepare statement: " . $dbh->errstr;
    $sth->execute() ;
    $sth->bind_columns(\$iSongId, \$cTitle, \$cArtist, \$cAlbum, \$cGenre) ;
    while ($sth->fetchrow_array ) {
        # Recherches des id artistes et albums
        my $sql_Artist = "SELECT cArtistName FROM artistTable WHERE (iArtistId = $cArtist)";
        my $sql_Album = "SELECT cAlbumTitle FROM albumTable WHERE (iAlbumId = $cAlbum)";
        my $sth_Art=$dbh->prepare($sql_Artist) ;
        my $sth_Alb=$dbh->prepare($sql_Album) ;
        
        $sth_Art->execute() ;
        $sth_Art->bind_columns(\$cArtist);
        $sth_Art->fetchrow_array ;
        
        $sth_Alb->execute() ;
        $sth_Alb->bind_columns(\$cAlbum);
        $sth_Alb->fetchrow_array ;
                
        $table_Tag{$iSongId} = {'Titre'     => $cTitle,
                                'Artiste'   => $cArtist,
                                'Album'     => $cAlbum,
                               } ;
       
    }
    $sth->finish ;
    $dbh->disconnect ;
    return %table_Tag ;
}

sub inserer_bdd {
    my ($filename, @mp3tag) = @_ ; # arguments passs
    my ($album, $artist, $dir, $genre, $playlist, $playsong, $song );
    # @mp3tag = valider_Tag (@mp3tag ) ;
        $dbh = DBI->connect("dbi:SQLite2:$ptmontage$bdd","","") ;# Connection  la BDD
        $album = gerer_Album ($mp3tag[2]) ;
        $artist = gerer_Artiste ($mp3tag[1]) ;
        $dir = gerer_Dir() ;
        $genre = gerer_Genre ($mp3tag[6]) ;
        $playlist = gerer_Playlist (); #(@mp3tag) ;
        $playsong = gerer_Playsong (); #(@mp3tag) ;
        $song = gerer_Song ($filename, @mp3tag, $album, $artist, $dir, $genre, $playlist, $playsong) ;
        
        $dbh->disconnect ;
    
}

sub gerer_Album {
    my ($tagdata) = @_ ;
    my (@data, $idAlbum) ;
    my $sql = " SELECT * FROM albumTable WHERE (cAlbumTitle = '$tagdata') " ;
    my $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
    $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
    @data = $sth->fetchrow_array() ;
    if (@data) { # Album dja dans la base 
        $idAlbum = $data[0] ;
        $sth->finish ;
    }
    else { # Album inconnu  ajouter 
        $sql = "INSERT INTO albumTable (cAlbumTitle) VALUES ('$tagdata') " ;
        $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
        $sth->finish ;
        
        $sql = " SELECT * FROM albumTable WHERE (cAlbumTitle = '$tagdata') " ;
        $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
        @data = $sth->fetchrow_array() ;
        if (@data) { # Album dja dans la base 
            $idAlbum = $data[0] ;
            $sth->finish ;
        }
        #gerer_Album (@_) ; # pour tre sur on boucle sur nous-mme
    }
    return $idAlbum ;
}

sub gerer_Artiste {
    my ($tagdata) = @_ ;
    my (@data, $idArtist) ;
    my $sql = " SELECT * FROM artistTable WHERE (cArtistName = '$tagdata') " ;
    my $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
    $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
    @data = $sth->fetchrow_array() ;
    if (@data) { # Artiste dja dans la base 
        $idArtist = $data[0] ;
        $sth->finish ;
    }
    else { # Artiste inconnu  ajouter 
        $sql = "INSERT INTO artistTable (cArtistName) VALUES ('$tagdata') " ;
        $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
        $sth->finish ;
        
        $sql = " SELECT * FROM artistTable WHERE (cArtistName = '$tagdata') " ;
        $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
        @data = $sth->fetchrow_array() ;
        if (@data) { # Artiste dja dans la base 
            $idArtist = $data[0] ;
            $sth->finish ;
        }
        #gerer_Artiste (@_) ; # pour tre sur on boucle sur nous-mme
    }
    return $idArtist ;
}

sub gerer_Dir {
    # Rien  faire, cette table n'a pas a tre modifier
    return 4;
}

sub gerer_Genre {
    my ($tagdata) = @_ ;
    my (@data, $idGenre) ;
    my $sql = " SELECT * FROM genreTable WHERE (cGenreName = '$tagdata') " ;
    my $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
    $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
    @data = $sth->fetchrow_array() ;
    if (@data) { # Artiste dja dans la base 
        $idGenre = $data[0] ;
        $sth->finish ;
    }
    else { # Artiste inconnu  ajouter 
        $sql = "INSERT INTO genreTable (cGenreName) VALUES ('$tagdata') " ;
        $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
        $sth->finish ;
        $sql = " SELECT * FROM genreTable WHERE (cGenreName = '$tagdata') " ;
        $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
        @data = $sth->fetchrow_array() ;
        if (@data) { # Artiste dja dans la base 
            $idGenre = $data[0] ;
            $sth->finish ;
        }
        #gerer_Genre (@_) ; # pour tre sur on boucle sur nous-mme
    }
    return $idGenre ;
}

sub gerer_Playlist {
    # A implementer plus tard peu tre
    return 0; # Un retour pour avoir un nombre de variable constant pour gerer_song()
}

sub gerer_Playsong {
    # A implementer plus tard peu tre
    return 0; # Un retour pour avoir un nombre de variable constant pour gerer_song()
}

sub gerer_Song {
    my ($fichiernom, @tagid) = @_ ;
    my ($sth, @data, @track) ;
    my $itracknr=0 ;
    my $sql=" " ;
    $sql = " SELECT cFileName,cSongTitle FROM songTable WHERE (cFileName = '$tagid[11]') " ;
    $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
    $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
    @data = $sth->fetchrow_array() ;
    $sth->finish ;
    if (@data) {
        print "cette chanson est deja enregistre sous le nom : $data[1] , fichier : $data[0] ! \n\n" ;
        $sth->finish ;
        return 0 ;
    }
    else {
        # rcuperation du n de piste (le plus elev + 1)
        my $sqltrack = "SELECT iTrackNr FROM songTable ORDER by iTrackNr COLLATE iTrackNr DESC " ;
        $sth = $dbh->prepare($sqltrack) or die "Impossible chercher n de piste" . $dbh->errstr ;
        $sth->execute() or die "Impossible executer n de piste" . $sth->errstr;
        @track=$sth->fetchrow_array() ;
        $itracknr = $track[0] +1;
        $sth->finish ;
        
        # Insertion de la piste dans la table 
        
        $sql="";
        $sql = "INSERT INTO songTable 
            (cSongTitle, iArtistId, iAlbumId, iTrackNr, iTrackLength, iNrPlayed, cFileName, iDirId, iYear, iGenreId, iBitRate, iSampleRate, iFileSize, iMediaType) 
            VALUES 
           ('$tagid[0]', '$tagid[13]', '$tagid[12]', '$itracknr', '$tagid[8]', '0', '$tagid[11]', '$tagid[14]', '$tagid[3]', '$tagid[15]', '$tagid[7]', '$tagid[9]', '$tagid[10]', '1' ) " ;
           
        $sth = $dbh->prepare($sql) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
        
        #enregistrer sur le disque
        my $destination = $ptmontage.$repchant.$tagid[11] ;
        $fichiernom = "\"$fichiernom\"";
        open(FICHIER,"cp $fichiernom $destination|") ;
        close(FICHIER) ;
    }
}

sub supprimer_Bdd {
    my @criteres = @_ ;
    # prparation de l'idAlbum et idArtist
    #Creation de la requete
    $sql_Id = "SELECT iAlbumId, iArtistId, cFileName FROM songTable WHERE (" ;
    for (my $i=1; $i <= scalar( @criteres); $i++) {
        $sql_Id = $sql_Id . " csongTitle = \'$criteres[$i-1]\'";
        $sql_Id = $sql_Id . " OR" if $i < scalar( @criteres) ;
    }
    $sql_Id = $sql_Id . " )";
    #fin creation requete
    
    $dbh = DBI->connect("dbi:SQLite2:$ptmontage$bdd","","") or die "Couldn't connect to database: ". DBI->errstr;
    my $sth = $dbh->prepare($sql_Id) or die "Couldn't prepare statement: " . $dbh->errstr;
    $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
    $sth->bind_columns(\$idAlbum, \$idArtist, \$filename) or die "Pas de bind";
    my ($non_Album, $non_Artist,$test_Album,$test_Artist)= (0,0,"","");
    while ( $sth->fetch()) {
        foreach $element (@idAlbums) {
            $test_Album = $test_Album.$element ;
            $non_Album=1 if ($test_Album =~ m/$idAlbum/) ;
        }
        foreach $element (@idArtists) {
            $test_Artist = $test_Artist.$element ;
            $non_Artist=1 if ($test_Artist =~ m/$idArtist/) ;
        }
        @idAlbums   = (@idAlbums, $idAlbum)     if ($non_Album  != 1);
        @idArtists  = (@idArtists, $idArtist)   if ($non_Artist != 1) ;
        ($non_Album, $non_Artist) = () ;
        
        # Suppression effective  du disque
        my $cmd =$cmd.$ptmontage.$repchant.$filename ;
        open(FIC,"rm $cmd|");
        close(FIC);
        # fin suppression
    }
    $sth->finish ;
    # Fin rcuperation idAlbums et idArtists
    
    # Suppression des chansons selectionnes
    #creation requete
    my $sql_Song = "DELETE FROM songTable WHERE (";
    for (my $i=1; $i <= scalar( @criteres); $i++) {
        $sql_Song = $sql_Song . " csongTitle = \'$criteres[$i-1]\'";
        $sql_Song = $sql_Song . " OR" if $i < scalar( @criteres) ;
    }
    $sql_Song = $sql_Song . " )";
    # fin creation requete
    $sth = $dbh->prepare($sql_Song) or die "Couldn't prepare statement: " . $dbh->errstr ;
    $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
    $sth->finish ;
    
    #Maintenant on recherche si l'album doit tre supprimer ou non
    foreach $element (@idAlbums) {
        my $sql_Album = "SELECT iAlbumId FROM songTable where ( iAlbumId = $element )";
        my $sth = $dbh->prepare($sql_Album) or die "Couldn't prepare statement: " . $dbh->errstr ;
        $sth->execute() ; #or die "Could'nt execute statement : " .$sth->errstr ;
        my @resultat = $sth->fetchrow_array() ;
        if (@resultat) { # Album toujours rfrenc, on ne fait rien
        }
        else { #Album inconnu de songTable
            my $sql_Supp_Album = "DELETE FROM albumTable WHERE (iAlbumId = $element )" ;
            my $sth = $dbh->prepare($sql_Supp_Album) or die "Couldn't prepare statement: " . $dbh ;
            $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
            $sth->finish ;
        }
        $sth->finish ;
     }
     
     #Maintenant on recherche si l'artiste doit tre supprimer ou non
    foreach $element (@idArtists) {
        my $sql_Artist = "SELECT iArtistId FROM songTable where ( iArtistId = $element )";
        my $sth = $dbh->prepare($sql_Artist) or die "Couldn't prepare statement: " . $dbh ;
        $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
        my @resultat = $sth->fetchrow_array() ;
        if (@resultat) { # Artiste toujours rfrenc, on ne fait rien
        }
        else { #Artiste inconnu de songTable
            my $sql_Supp_Artist = "DELETE FROM artistTable WHERE (iArtistId = $element )" ;
            my $sth = $dbh->prepare($sql_Supp_Artist) or die "Couldn't prepare statement: " . $dbh ;
            $sth->execute() or die "Could'nt execute statement : " .$sth->errstr ;
            $sth->finish ;
        }
        $sth->finish ;
     }

     
    $dbh->disconnect ;
    
    
}

sub valider_Tag {
    my @tag_valider ;
    
    foreach $tag_valider (@_) {
        $tag_valider =~ s/'/''/g ; # On substitue un ' par deux '' pour SQLite2
        @tag_valider = (@tag_valider, $tag_valider) ;
    }
    return @tag_valider ;
}

1;
